package org.jboss.security.plugins;

import java.security.Principal;
import java.util.List;
import javax.management.ObjectName;
import org.jboss.mx.util.ObjectNameFactory;
import org.jboss.security.SecurityDomain;
import org.jboss.security.plugins.SecurityManagerMBean;
import org.jboss.system.ServiceMBean;

public interface JaasSecurityManagerServiceMBean extends ServiceMBean, SecurityManagerMBean {

   ObjectName OBJECT_NAME = ObjectNameFactory.create("jboss.security:service=JaasSecurityManager");


   boolean getServerMode();

   void setServerMode(boolean var1);

   String getSecurityManagerClassName();

   void setSecurityManagerClassName(String var1) throws ClassNotFoundException, ClassCastException;

   String getSecurityProxyFactoryClassName();

   void setSecurityProxyFactoryClassName(String var1) throws ClassNotFoundException;

   String getCallbackHandlerClassName();

   void setCallbackHandlerClassName(String var1) throws ClassNotFoundException;

   String getAuthenticationCacheJndiName();

   void setAuthenticationCacheJndiName(String var1);

   int getDefaultCacheTimeout();

   void setDefaultCacheTimeout(int var1);

   int getDefaultCacheResolution();

   void setDefaultCacheResolution(int var1);

   void setCacheTimeout(String var1, int var2, int var3);

   void flushAuthenticationCache(String var1);

   void flushAuthenticationCache(String var1, Principal var2);

   List getAuthenticationCachePrincipals(String var1);

   void registerSecurityDomain(String var1, SecurityDomain var2);

   String getDefaultUnauthenticatedPrincipal();

   void setDefaultUnauthenticatedPrincipal(String var1);

}
